//-----------------------------------------------------------
//
// SSE2030: Introduction to Computer Systems (Fall 2010)
//
// Test Program code for PA#1 (Windows)
//
// September 14, 2010.
// Hyeong-Jun Kim
// Sungkyunkwan University
//
//-----------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

int xmatch(char* input, int len, char* output);

int main(int argc, char* argv[]) {
	char filePath[5][2][12] = {
			{"./input_01","./output_01"},
			{"./input_02","./output_02"},
			{"./input_03","./output_03"},
			{"./input_04","./output_04"},
			{"./input_05","./output_05"}
		};
	char* input;
	char* TAoutput;
	char* STUoutput;

	int iter;
	int result;
	int len;
	int correctOutputSize;
	clock_t start_t, end_t;
	int ubound;

	FILE *fpInput, *fpOutput;
	int selectedProgram = 0;
	int numOfRead = 0;
	
	int numOfIncorrectBytes = 0;

	if(argc!=2 || argv[1][0]<'1' || argv[1][0]>'5') {
		printf("USAGE : %s [TEST PROGRAM CODE : 1-5]\n", argv[0]);
		exit (1);
	}
	selectedProgram = argv[1][0]-'0'-1;

	selectedProgram = 1;
	fpInput = fopen(filePath[selectedProgram][0], "rb");
	if(!fpInput) {
		printf("Error : file open\n");
		exit (1);
	}
	
	fseek(fpInput, 0, SEEK_END);
	len = ftell(fpInput);
	fseek(fpInput, 0, SEEK_SET);
	
	fpOutput = fopen(filePath[selectedProgram][1], "rb");
	if(!fpOutput) {
		printf("Error : file open\n");
		exit (1);
	}
	
	fseek(fpOutput, 0, SEEK_END);
	correctOutputSize = ftell(fpOutput);
	fseek(fpOutput, 0, SEEK_SET);
	
	input = (char*)malloc(len);
	if (input == NULL)
	{
		printf("malloc() failed. exiting...\n");
		exit (1);
	}
	
	numOfRead = fread(input, 1, len, fpInput);
	if(numOfRead!=len) {
		printf("Cannot read all file\n");
		exit (1);
	}

	TAoutput = (char*)malloc(correctOutputSize);
	numOfRead = fread(TAoutput, 1, correctOutputSize, fpOutput);
	if(numOfRead!=correctOutputSize) {
		printf("Cannot read all file\n");
		exit (1);
	}

	STUoutput = (char*)malloc(len*2);
	if (STUoutput == NULL)
	{
		printf ("malloc() failed. exiting...\n");
		exit (1);
	}
	memset(STUoutput, 0, len*2);

	printf("SSE2030 PA#1: Simplified X-Match algorithm\n");
	printf("------------------------------------------\n");

	//----------------------------------------------------
	start_t = clock();
	result = xmatch(input, len, STUoutput);
	end_t = clock();
	//----------------------------------------------------
	
	printf("- Test program #%.2d\n\n", selectedProgram+1);
	printf("   * Original bytes \t\t: \t%d\n", len);
	printf("   * Correct output Size \t: \t%d\n", correctOutputSize);
	printf("   * Correct compression ratio \t: \t%2.2f %%\n",
			(double)correctOutputSize/(double)len*100.0);

	if(result>=0) {
		printf("\n- Your Result\n\n");
		printf("   * Compressed bytes \t\t: \t%d\n", result);
		printf("   * Compression ratio \t\t: \t%2.2f %%\n", 
			(double)result/(double)len*100.0);
		printf("   * Total elapsed time \t: \t%.2lf (sec)\n", 
			(double)(end_t-start_t)*CLOCKS_PER_SEC);

		printf("\n- Summary\n\n");
		printf("   * Compare Output size \t: \t%s\n", 
				(result==correctOutputSize)? "PASS":"FAIL");
		printf("   * List of different contents : \t");
		if (result>correctOutputSize)
			ubound = correctOutputSize;
		else
			ubound = result;

		for(iter=0; iter<ubound; iter++) {
			if(STUoutput[iter]!=TAoutput[iter]) {
				numOfIncorrectBytes++;
				printf("\n      %5d byte : (TA)0x%.2x (YOUR)0x%.2x",
						iter+1, (unsigned char)TAoutput[iter], 
						(unsigned char)STUoutput[iter]);
			}
		}
		
		if(numOfIncorrectBytes>0) 
			printf("\n   * Total %d bytes are incorrect\n", numOfIncorrectBytes);
		else
			printf("NONE\n");

		if(numOfIncorrectBytes==0 && result==correctOutputSize)
			printf("\n   ** Correct Output **\n");
		else
			printf("\n   ** Incorrect Output **\n");
	}
	else {
		printf("\nError in xmatch() function.\n");
	}

	return 0;
}
